<?php
/*
 * dbadminister.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */

/* This page enbles the administrator to upload and update PO files
 * to database. The administrator can uninstall the application too.
 *
 *                                                        Author: Vigneswaran R
 */

//starting the session
include ("include/header_info.php");

//checking for authorized user from session values
($_SESSION['user_role'] == "administrator") 
    or exit("<h2>Unauthorized Access!!!</h2><br /><hr>You are trying to access " .
            "restricted content. Your access has been logged.<br />If you have " .
            "reached this page by mistake, kindly close this window.<br /><br /> ".
            "<pre>Administrator</pre>");

    //files containing supporting functions
    include ("include/functions_common.php");
    include_once ("include/functions_stat.php");
    include ("include/functions_dbadminister.php");
    
    $upload_po     = $_POST["upload_po"];
    $recover_po    = $_POST["recover_po"];
    $uninstall     = $_POST["uninstall"];
    $background    = $_POST["background"];
    $branch_id     = $_POST["branch_id"];
    $branch_name   = $_POST["branch_name"];
    $parent_branch = $_POST["parent_branch"];
    $lang          = $_POST["lang"];
    $lang_name     = $_POST["lang_name"];
    $lang_code     = $_POST["lang_code"];
    $create_branch = $_POST["create_branch"];
    $remove_branch = $_POST["remove_branch"];
    $add_lang      = $_POST["add_lang"];
    $remove_lang   = $_POST["remove_lang"];
    
    $user       = $_SESSION['user'];
    $user       = ($user) ? $user : "guest"; //else part won't occur

    $disable_recover = "disabled";
    $disable_upload  = "";
    $parentindex     = 2; //index for parent id in $pid_file entry
    $langindex       = 3; //index for language in $pid_file entry
    $userindex       = 5; //index for user name in $pid_file entry
    
    $db_conn    = dbConnect();

    if(substr($dir,-1)!="/")
        $dir .= "/";
    
    if($upload_po)
    {
        $ret_val = fn_upload($_FILES['userfile']['name'],
                           $_FILES['userfile']['tmp_name'],$dir."temp_upload/".$user);

        if($ret_val) {
            $ret_val = fn_update($_FILES['userfile']['name'],$dir."temp_upload/".$user,
                                $branch_id,$lang,$background,false);
        }
        
        if(!$ret_val) {
            $ret_val = $error_msg;
        }
    }
    else if($recover_po)
    {
        $ret_val = fn_update("recovery.list",$dir."temp_upload/".$user,$branch_id,
                   $lang,$background,true);
                   
        if(!$ret_val) {
            $ret_val = $error_msg;
        }
    }
    else if($uninstall)
    {
        $ret_val = fn_uninstall();
        
        $_SESSION = array();
        session_destroy();
        if($ret_val) {
            header("Location:main.php");
        }
        else {
            exit("<center>$error_msg<br><a href=\"main.php\">Home</a></center>");
        }
    }
    else if($create_branch)
    {
        $ret_val = insertNode($branch_name, $parent_branch, 0, '');
        
        if($ret_val) {
            $ret_val = "Branch - <i>$branch_name</i> - was succesfully created";
        }
        else {
            $ret_val = $error_msg;
        }
    }
    else if ($remove_branch)
    {
        $ret_val = removeNode($parent_branch);
        
        if ($ret_val) {
            $ret_val = "Branch was succesfully removed";
        }
        else {
            $ret_val = $error_msg;
        }
    }
    else if($add_lang)
    {
        $ret_val = addLang($lang_name,$lang_code);
        
        if(!$ret_val) {
            $ret_val = $error_msg;
        }
    }
    else if($remove_lang)
    {
        $ret_val = removeLang($lang);
        
        if(!$ret_val) {
            $ret_val = $error_msg;
        }
    }
    else if(!isAnyProcessAlive($user))
    {
        if(isAnyAbnormalTerm($user)) {
            if(isAnyUploadedFile($dir."temp_upload/".$user)) {
                $upload_details = getUploadDetails($user);
                $branch_id  = $upload_details[$parentindex];
                $lang       = $upload_details[$langindex];
                
                $ret_val = "Last updation process has been terminated abnormally.<br>" .
                "Please click the button 'Recover' to restart updation process.";
                $disable_recover = "";
                $disable_upload  = "disabled";
            }
            else {
                delPIDEntry($userindex,$user);
            }
        }
        else if(isAnyUploadedFile($dir."temp_upload/".$user)) {
            $ret_val = "Last updation process has been terminated abnormally.<br>" .
            "Please select appropriate branch and language value and click the button 'Recover'.";
            $disable_recover = "";
            $disable_upload  = "disabled";
        }
    }
    
    include ("head.php");   //wiki style header  
?>

<script language="JavaScript" type="text/javascript" src="scripts/dbadminister.js"></script>
<script language="JavaScript" type="text/javascript" src="scripts/common.js"></script>

<?php
    include("body.php");    //wiki style body
?>
<style type="text/css">
<!--
.tablesmall {
    border: 1pt solid #ADB9CC;
}
.tdbottom {
    background: #EEEEEE;
    padding: 5px;
}
.buttonbar li{
    float: left;
}
-->
</style>
<!--
<div id="tab">
-->
    <ul id="navibar">
        <li class="wikilink"><a href="main.php">Home</a></li>
        <li class="wikilink"><a href="list.php?category=untrans&amp;page=1">
            Untranslated Strings</a></li>
        <li class="current"><a href="dbadminister.php">Database Administration</a></li>
        <li class="wikilink"><a href="help.php">Help</a></li>
    </ul>

    <div id="pageline"><hr style="display:none;"></div>
    
</div>

<div id="page">

    <div id="drophelp" class="drophelpdiv"></div>

    <div class="msg">
        <span style="float:left">
            <?php echo $ret_val; ?>
        </span>
    </div>
    
    <ul class="buttonbar" style="clear:none">
        <li class="buttonlink">
            <a href="organize.php" >Organize Files</a>
        </li>
    </ul>
    
    <br/>
    <form name="upload_form" method="post" action="" enctype="multipart/form-data" 
                                                    onSubmit="return fn_verify()">

    <input type="hidden" name="MAX_FILE_SIZE" value="2000000">
    <table class="tablesmall" >
    <tr>
        <td colspan="3" class="tdbottom"><div id="sub_title">Upload / Recover Files</div></td>
    </tr>
    <tr>
        <td>Parent branch </td>
        <td>
            <select name="branch_id" class="submit_sel">
            <?php
                $list_dir = getBranchList();
                $num_dir  = count($list_dir);
                if ($num_dir)
                {
                    $list_dir = orderBy($list_dir,"path");
                    for ($i=0; $i<$num_dir; $i++)
                    {
                        $dir_id   = $list_dir[$i]["id"];
                        $dir_path = $list_dir[$i]["path"];
                        $selected = "";
                        if($dir_id == $branch_id) {
                            $selected = 'selected';
                        }
                        echo "<option value='$dir_id' $selected>$dir_path</option>";
                    }
                }
            ?>
            </select>
        </td>
        <td>&nbsp;</td>
    </tr>
    <tr>
        <td>Language</td>
        <td colspan=2>
            <select name="lang" class="submit_sel">
            <option value=''>&lt;select language&gt;</option>
            <?php
                $lang_list  = getAllLang();
                $lang_count = count($lang_list);
                for ($index = 0; $index < $lang_count; $index++)
                {
                    $code     = $lang_list[$index]["code"];
                    $language = $lang_list[$index]["language"];
                    $selected = "";
                    if($lang == $code) {
                        $selected = 'selected';
                    }
                    echo "<option value='$code' $selected>$language</option>";
                }
            ?>
            </select>
            </td>
        </tr>
        <tr>
        <?php
            $result = isPHPInPath();
            if(!$result) {
                echo "<td colspan=2><input type=\"hidden\" name=\"background\" value=0>\n";
            }
            else {
        ?>
            <td>Run in background</td>
            <td colspan=2><input name="background" type="checkbox" checked>
                <small>
                <a href="#" 
                onMouseOver="changetext(content[2]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
        <?php
            }
        ?>
        </tr>
        <tr>
            <td>File for upload</td>
            <td colspan=2><input name="userfile" type="file" class="file_browse"></td>
        </tr>
        <tr>
            <td>Upload selected file</td>
            <td colspan=2><input name="upload_po" type="submit" class="submit"
                            <?php echo $disable_upload; ?>
                            value="Upload" onClick="fn_upload_po()">
                <small>
                <a href="#" 
                onMouseOver="changetext(content[0]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
        </tr>
        <tr>
            <td>Start recovery process</td>
            <td colspan=2><input type="submit" name="recover_po" class="submit" 
                            <?php echo $disable_recover; ?>
                            value="Recover" onClick="fn_recover_po()">                                 
                <small>
                <a href="#" 
                onMouseOver="changetext(content[5]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
        </tr>
    </table>
    </form>
   <br/> 
    <form name="edit_branch_form" method="POST" action="" onSubmit="return fn_verify()">
    <table class="tablesmall" >
    <tr>
        <td colspan="3" class="tdbottom"><div id="sub_title">Add / Remove Branch</div></td>
    </tr>
    <tr>
        <td>Parent branch</td>
        <td>
        <select name="parent_branch" class="submit_sel">
        <?php
            if ($num_dir)
            {
                for ($i=0; $i<$num_dir; $i++)
                {
                    $dir_id   = $list_dir[$i]["id"];
                    $dir_path = $list_dir[$i]["path"];
                    echo "<option value='$dir_id'>$dir_path</option>";
                }
            }
        ?>
        </select>
        </td>
        <td><input  type="button" name="delete_branch" value="Remove" 
            onClick = "fn_remove_branch();" class="smallbutton">
            <small>
            <a href="#" 
            onMouseOver="changetext(content[6]);cssdropdown.dropit(this,event,'drophelp');">
            Help</a>
            </small>
            <input type="hidden" name="remove_branch" value="">
        </td>
    </tr>
    <tr>
        <td>Branch name</td>
        <td><input type="textbox" name="branch_name" class="submit_txt">
        </td>
        <td><input type="submit" name="create_branch" value="Add" 
            onClick = "fn_create_branch();" class="smallbutton">
            <small>
            <a href="#" 
            onMouseOver="changetext(content[7]);cssdropdown.dropit(this,event,'drophelp');">
            Help</a>
            </small>
        </td>
    </tr>
    </table>
    </form>
   <br/> 
    <form name="add_lang_form" method="post" action="" onSubmit="return fn_verify()">
    <table class="tablesmall" >
        <tr>
            <td colspan="3" class="tdbottom"><div id="sub_title">Add / Remove Language</div></td>
        </tr>
        <tr>
            <td>Language name</td>
            <td>
                <input type="text" name="lang_name" class="submit_txt">
            </td>
            <td rowspan=2>
                <input type="submit" name="add_lang" class="smallbutton"
                            value="Add" onClick="fn_add_lang();">                                 
            </td>
        </tr>
        <tr>
            <td>Language code</td>
            <td>
                <input type="text" name="lang_code" class="submit_txt">
                <small>
                <a href="#" 
                onMouseOver="changetext(content[4]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
        </tr>
        <tr>
            <td>Language name</td>
            <td><select name="lang" class="submit_sel">
                <option value=''>&lt;select language&gt;</option>
                <?php
                    for ($index = 0; $index < $lang_count; $index++)
                    {
                        $code     = $lang_list[$index]["code"];
                        $language = $lang_list[$index]["language"];
                        
                        echo "<option value='$code'>$language</option>";
                    }
                ?>
                </select>
            </td>
            <td>
                <input type="submit" name="remove_lang" class="smallbutton"
                            value="Remove" onClick="fn_remove_lang();">
            </td>
        </tr>
    </table>
    </form>
    <br/>
    <form name="uninstall_form" method="post" action="" onSubmit="return fn_verify()">
    <table class="tablesmall" >
        <tr>
            <td colspan="2" class="tdbottom"><div id="sub_title">Uninstall</div></td>
        </tr>
        <tr>
            <td>Delete the database tables and configuration file for this 
            application</td>
            <td><input type="submit" name="uninstall" class="submit" 
                            value="Uninstall" onClick="fn_uninstall()">                                 
                <small>
                <a href="#" 
                onMouseOver="changetext(content[1]);cssdropdown.dropit(this,event,'drophelp');">
                Help</a>
                </small>
            </td>
        </tr>
    </table>
    </form>
</div>
<br/>
<?php
    mysql_close($db_conn);
    include ("footer.php");        //wiki style footer
?>
