<?php
/*
 * functions_organize.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */
 
/*  This file contains supporting functions for organize.php
 *
 *								AUTHOR: Khader Abbeb N, Vigneswaran R
 */

include ("functions_organize_dbadminister.php");
include ("functions_edit_poheader.php");

function insertBox($parent_id)
{
	global $table_file_details;
	$branch_name	= getNodeName($parent_id);
	echo '<ul class="filebox">';
	echo '<li class="branch">'. $branch_name .'</li>';
	echo '</ul>';
        echo '<div class="boxline">';
	$sql_get_child_po	= "select node_id, node_name, is_po from $table_file_details ".
				  "where parent_id = '$parent_id' order by is_po desc, node_name";
	$result_get_child_po	= mysql_query($sql_get_child_po);
	if (mysql_num_rows($result_get_child_po))
	{
	    $index	= 0;
	    echo '<ul class="filelist" >';
	    while ($row_get_child_po	= mysql_fetch_row($result_get_child_po))
	    {
		$node_id	= $row_get_child_po[0];
		$node_name	= $row_get_child_po[1];
		$is_po		= $row_get_child_po[2];
		if ($is_po)
		{
		    echo '<li>';
		    echo '<input type="checkbox" name="file_list[]" value='.$node_id.'> '.$node_name ;
		    echo '</li>';
		}
		else
		{
		    insertBox($node_id);
		}
	    }
	    echo '</ul>';
	}
	else
	{
	    echo "<i>(Empty)</i>";
	}
	echo '</div>';
}
    
function fn_make_child_pofiles($file_id, $file_name, $path, $is_po)
{    
    global $error_msg;

    if (substr($path, -1)!="/")
        $path .= "/";

    if ($is_po) {
        $ret_val = fn_make_pofile($file_id, $path, false);
        return $ret_val;
    }
    else {
        $nodes_list = getChild($file_id);
        if (!$nodes_list) {
            $error_msg = "Error: No po files found in the branch $file_name.";
            return false;
        }
        foreach($nodes_list as $node) {
            fn_make_child_pofiles($node[0], $node[1], $path.$file_name, $node[2]);
        }
    } 
    return true;
}

function fn_make_pofile_list($file_list, $path)
{
    global $error_msg;

    if (substr($path, -1)!="/") {
        $path .= "/";
    }
    if (!$file_list) {
        $error_msg = "Error: No files were specified.";
        return false;
    }

    $parent = isUnderSameParent($file_list);
    
    foreach($file_list as $file_id)
    {
        if ($parent) {
            $parent_name = $parent;
            $file_name   = $parent;
        }
        else {
            $parent_name = implode("/", getPath($file_id));
            $file_name   = "top";
        }
        $ret_val = fn_make_pofile($file_id, $path.$parent_name, false);
        if (!$ret_val) {
            return false;
        }
    }
    return $file_name;
}

function fn_download($file_name, $temp_file, $path)
{
//downloads the file and deletes it

    if (substr($path, -1)!="/") {
        $path .= "/";
    }

//exit("file_name $file_name temp_file $temp_file");

    //content type of the file to be downloaded
    header('Content-Type: text/plain; charset=UTF-8');
       
    //file's contents needs to be downloaded, not to be displayed
    header('Content-Disposition: attachment; filename='.$file_name);
    
    readfile($path.$temp_file);
  
    fn_delete_file($temp_file, $path);
    
    exit();
}

function fn_compress($file_name, $path, $type)
{
//compresses the file

    if ($type == ".tar.gz") {
        $cmd = "tar -cvzf";
        $compressed_file_name = $file_name.$type;
    }
    `cd $path;$cmd $compressed_file_name $file_name;`;
    
    return $compressed_file_name;
}

function fn_make_pofile($file_id, $path, $use_temp_filename)
{
    //creates the po file by taking information from database

    //table names have been defined in database.conf.php file
    global $table_string_list, $table_string_context, $table_suggestion;
    global $table_poheader, $error_msg;
    
    if (!$file_id) {
        $error_msg = "Error: No files were specified.";
        return false;
    }
    $file_name = getNodeName($file_id);
    if (!$file_name) {
        $error_msg = "Error: Invalid file id.";
        return false;
    }
    if (substr($path, -1)!="/")
        $path .= "/";

    if (!is_dir($path) && !mkdirs($path)) {
        $error_msg = "Error: Path $path doesn't exist.";
        return false;
    }

    $temp_file = $file_name;
    if ($use_temp_filename) {
        $temp_file .= "_".date('YmdHis');
    }
    $output_file = $path.$temp_file;

    if (file_exists($output_file)) {
        $error_msg = "Error: File creation error. Please try again.";
        return false;
    }
    //create a file with the selected PO file's name
    if (!($output_file_handle = @fopen($output_file, "w"))) {
        $error_msg = "Error: Can not create output file '$output_file'. " .
                     "Check the permissions.";
        return false;
    }
    chmod($output_file, 0666);

    //Take the header from table and put it into the new .po file
    //fn_read_poheader() is defined in functions_edit_poheader.php
    $poheader = fn_read_poheader($file_id);
    
    fputs($output_file_handle, $poheader."\n");

    $select_query_singular = "select c.context, l.string_value, l.plural_string_id, " .
                    "c.is_fuzzy, s.user_suggestion, s.comments " .
                    "from $table_string_context as c, $table_string_list as l, " .
                    "$table_suggestion as s where " .
                    "c.string_id=l.string_id and c.file_id=$file_id and " .
                    "c.valid_sug_id=s.sug_id and c.is_plural=0 order by c.context_id";
    
    $select_query_plural = "select l.string_value, l.string_id, s.user_suggestion, " .
                    "s.comments from $table_string_context as c, " .
                    "$table_string_list as l, $table_suggestion as s where " .
                    "c.string_id=l.string_id and c.file_id=$file_id and " .
                    "c.valid_sug_id=s.sug_id and c.is_plural=1 order by c.context_id";
   
    $sql_result_singular = mysql_query($select_query_singular);

    if (!$sql_result_singular)
    {
        $error_msg = "Error#1: " . mysql_error();
        return false;
    }
    
    $sql_result_plural = mysql_query($select_query_plural);

    if (!$sql_result_plural)
    {
        $error_msg = "Error#2: " . mysql_error();
        return false;
    }

    $result_arr_plural = array();
    $plural_index = 0;
    while ($row=mysql_fetch_row($sql_result_plural)) {
        $result_arr_plural[$plural_index]["string_value"]    = $row[0];
        $result_arr_plural[$plural_index]["string_id"]       = $row[1];
        $result_arr_plural[$plural_index]["user_suggestion"] = $row[2];
        $result_arr_plural[$plural_index]["comments"]        = $row[3];
        $plural_index++;
    }

    while ($row=mysql_fetch_assoc($sql_result_singular)) {
        
        $output_string       = "";
        $trans_comments      = "";
        $context             = "";
        $string_value        = "";
        $string_value_plural = "";
        $current_translation = "";
        $current_translation_plural = "";

        $context             = $row["context"];
        $trans_comments      = $row["comments"];
        $string_value        = $row["string_value"];
        $current_translation = $row["user_suggestion"];

        if ($row["plural_string_id"] != -1 &&
           $row_plural = getRow($result_arr_plural, "string_id", $row["plural_string_id"]))
        {
            $string_value_plural        = $row_plural["string_value"];
            $current_translation_plural = $row_plural["user_suggestion"];

            if ($row_plural["comments"] != "" && $row_plural["comments"] != $trans_comments) {
                if ($trans_comments != "") {
                    $trans_comments .= "\n";
                }
                $trans_comments .= $row_plural["comments"];
            }
        }

        if ($trans_comments != "") {
            $temp_trans_comments = explode("\n", $trans_comments);
            $trans_comments = "";
            
            foreach($temp_trans_comments as $comment) {
                $trans_comments .= "#  " . $comment;
            }
            $context = $trans_comments . $context;
        }
    
        //tokenize the context using '#' as the delimiter
        $sub_context = strtok($context, "#");
        while ($sub_context) {
            $new_line = "";
            $comment_type = "#" . substr($sub_context, 0, 1);
            
            if ($comment_type == "#." || $comment_type == "#:" || 
               $comment_type == "#," || $comment_type == "# ")
            {
                $new_line = "\n";
            }
            $sub_context = rtrim($sub_context);
            if ($sub_context!="") {
                $output_string .= $new_line."#".$sub_context;
            }
            $sub_context=strtok("#");
        }
        
        if ($row["is_fuzzy"] == 1) {
            $output_string .= "\n#, fuzzy";
        }
        fputs($output_file_handle, $output_string."\n");
        
        fn_write_string($string_value, 77, "msgid ", $output_file_handle);
      
        $msgstr = "msgstr ";
        if ($string_value_plural != "") {
            fn_write_string($string_value_plural, 77, "msgid_plural ", $output_file_handle);
            $msgstr = "msgstr[0] ";
        }

        fn_write_string($current_translation, 77, $msgstr, $output_file_handle);

        if ($string_value_plural != "") {
            fn_write_string($current_translation_plural, 77, "msgstr[1] ", $output_file_handle);
        }
    }// foreach ends here
    
    fclose($output_file_handle);
    return $temp_file;
}

function getRow($list, $key, $value)
{
    foreach($list as $row)
    {
        if ($row[$key] == $value) {
            return $row;
        }
    }
    return false;
}
    

function fn_write_string($string_value, $length, $msgstr, $output_file_handle)
{
//this function writes the string to the output file.
//the line length in the output file can be set
    
    $output_string = "";
    
    $output_string .= $msgstr;
    
    $line_len=strlen($string_value);
    
    if (($line_len+strlen($msgstr))>$length||(($pos=strpos($string_value, "\\n"))
        &&$pos<$line_len-2))
    {
        //the line is greater in length than mentioned length
        $output_string .= "\"\"\n";
        $start=0;
        $pos=0;
        
        while ($line_len>0) {    //break the line into lines of specific length
            if ($line_len>$length) {
                $part_string_value=substr($string_value, $start, $length);
            }
            else {
                $part_string_value=substr($string_value, $start);
            }
            
            if (($pos=strpos($part_string_value, "\\n")) !== false) {
            
                $output_string .= "\"".substr($part_string_value, 0, $pos+2)."\"\n";
                $start+=$pos+2;
                $line_len-=$pos+2;
            }
            else if ($line_len>$length) {
            
                $pos=strrpos($part_string_value, " ");
                $output_string .= "\"".substr($part_string_value, 0, $pos+1)."\"\n";
                $start+=$pos+1;     //next character to white space
                $line_len-=$pos+1;
            }
            else {
                $output_string .= "\"".substr($string_value, $start)."\"\n";
                $line_len=0;
            }
        }
        
    }//if line length is greater than the given length ends here
    
    else {
        $output_string .= "\"".$string_value."\"\n";
    }
    fputs($output_file_handle, $output_string);
}

function fn_delete_file_contents($file_list) {
//deletes the information about a particular file from the database 

    global $table_string_context, $table_poheader, $table_file_details;
    global $error_msg;

    if (!$file_list) {
        $error_msg = "Error: No files were specified.";
        return false;
    }
    
    $partial_query_file_id = "";
    $partial_query_node_id = "";
    $file_name = "";
    if (is_array($file_list)) {
        $partial_query_file_id = "file_id=" . implode(" or file_id=", $file_list);
        $partial_query_node_id = "node_id=" . implode(" or node_id=", $file_list);
        
        if (count($file_list)==1) {
            $file_name = getNodeName($file_list[0]);
        }
    }
    else {
        $file_name = getNodeName($file_list);
        $partial_query_file_id = "file_id=$file_list";
        $partial_query_node_id = "node_id=$file_list";
    }

    $delete_query = "delete from $table_string_context where $partial_query_file_id";
    $sql_result = mysql_query($delete_query);

    if (!$sql_result)
    {
        $error_msg = "Error#3: " . mysql_error();
        return false;
    }

    $delete_query = "delete from $table_poheader where $partial_query_file_id";
    $sql_result = mysql_query($delete_query);

    if (!$sql_result)
    {
        $error_msg = "Error#4: " . mysql_error();
        return false;
    }
    
    $delete_query = "delete from $table_file_details where $partial_query_node_id ".
                    "and is_po=1";
    $sql_result = mysql_query($delete_query);

    if (!$sql_result)
    {
        $error_msg = "Error#5: " . mysql_error();
        return false;
    }

    if ($file_name) {
        $ret_val = "File $file_name has been deleted successfully.";
    }
    else {
        $ret_val = "Selected files have been deleted successfully.";
    }
    return $ret_val;
}

    function changeLanguage($file_list, $lang)
    {
        global $table_file_details, $table_string_context, $table_suggestion;
        global $error_msg;

        if (!$file_list) {
            $error_msg = "Error: No files were specified.";
            return false;
        }
        $partial_query_node = "node_id=" . implode(" or node_id=", $file_list);
        $partial_query_file = "file_id=" . implode(" or file_id=", $file_list);

        $sql_change_language = "update $table_file_details set lang='$lang' " .
                             "where $partial_query_node";
        $sql_result = mysql_query ($sql_change_language);

        if (!$sql_result)
        {
            $error_msg = "Error#6: " . mysql_error();
            return false;
        }

        $sql_select_lang = "select valid_sug_id from $table_string_context where " .
                            $partial_query_file;
        $result_select_lang = mysql_query($sql_select_lang);

        if (!$result_select_lang)
        {
            $error_msg = "Error#7: " . mysql_error();
            return false;
        }
        
        $partial_query = "";
        while ($row_lang = mysql_fetch_row($result_select_lang))
        {
            if ($partial_query) {
                $partial_query .= " or ";
            }
            $partial_query .= "sug_id=".$row_lang[0];
        }
        $sql_update_lang = "update $table_suggestion set lang='$lang' where $partial_query";
        $sql_result = mysql_query($sql_update_lang);

        if (!$sql_result)
        {
            $error_msg = "Error#8: " . mysql_error();
            return false;
        }
        return true;
    }

    function changeParent($file_list, $parent_id, $overwrite)
    {
        global $table_file_details, $error_msg;
        
        if (!$file_list) {
            $error_msg = "Error: No files were specified.";
            return false;
        }
        $partial_query_id = "node_id=" . implode(" or node_id=", $file_list);

        $sql_select_query = "select node_name, parent_id from $table_file_details " .
                            "where $partial_query_id";
        $sql_result = mysql_query($sql_select_query);

        if (!$sql_result)
        {
            $error_msg = "Error#9: " . mysql_error();
            return false;
        }
        
        $file_names = array();
        $parent_ids = array();
        while ($row = mysql_fetch_row($sql_result)) {
            $file_names[] = $row[0];
            $parent_ids[] = $row[1];
        }
        if (findPos($parent_ids, $parent_id)!=-1) {
            $error_msg = "Error: One or more files have same source and destination branch.";
            return false;
        }
        $partial_query_name = "node_name='" . implode("' or node_name='", $file_names) . "'";
        
        $sql_select_query = "select node_name, node_id from $table_file_details where " .
                            "parent_id=$parent_id and ($partial_query_name)";
        $sql_result = mysql_query($sql_select_query);

        if (!$sql_result)
        {
            $error_msg = "Error#10: " . mysql_error();
            return false;
        }
        
        unset($file_names);
        $file_ids = array();
        while ($row = mysql_fetch_row($sql_result)) {
            $file_names[] = $row[0];
            $file_ids[]   = $row[1];
        }
        
        $len = count($file_names);
        if ($len) {
            if (!$overwrite) {
                $error_msg = "Error: The following files are already present under " .
                             "the destination branch. To overwrite the files,  select " .
                             "overwrite and continue.<br>- " . implode("<br>- ", $file_names);
                return false;
            }
            else {
                fn_delete_file_contents($file_ids);
            }
        }
        $sql_change_parent = "update $table_file_details set parent_id=$parent_id " .
                             "where $partial_query_id";
        $sql_result = mysql_query ($sql_change_parent);

        if (!$sql_result)
        {
            $error_msg = "Error#11: " . mysql_error();
            return false;
        }
        return true;
    }

    function isUnderSameParent($file_list)
    {
        global $table_file_details, $error_msg;
        
        $partial_query = "node_id=" . implode(" or node_id=", $file_list);

        $sql_select_query = "select distinct parent_id from $table_file_details " .
                            "where $partial_query";
        $sql_result = mysql_query($sql_select_query);

        $error_msg = "";
        if (!$sql_result)
        {
            $error_msg = "Error#12: " . mysql_error();
            return false;
        }
        
        if (mysql_num_rows($sql_result) > 1) {
            return false;
        }
        return mysql_result($sql_result, 0, 0);
    }
    
    function findPos($elements, $element)
    {
        $len = count($elements);
        for ($index=0;$index<$len;$index++) {
            if ($elements[$index] == $element) {
                break;
            }
        }
        if ($index < $len) {
            $pos = $index;
        }
        else {
            $pos = -1;
        }
        return $pos;
    }

?>
