<?php
/*
 * translate.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */

include ("include/header_info.php");


/*	This is the User Suggestion page or Translation page. 
 *
 *	This page is used by the regular users (non-validators) to give their suggestion for a particular string 
 * or vote on an existing suggestion.
 *
 *	The Validators can use this page to Validate an existing suggestion, make their own suggestion or remove
 * any suggestion from the database.
 *
 *	The language in which the suggestion is to made must be selected from the drop down box on the top-left
 * corner. Once a language is selected the users can type in the selected language as long as they have any Unicode
 * fonts for that language. THE KEYBOARD NEED NOT BE SETUP/CONFIGURED FOR THE APPLICATION TO WORK.
 *
 *									AUTHOR: Khader Abbeb N	
 *
 */


include ("include/functions_common.php");
include_once ("include/functions_stat.php");
include ("include/functions_translate.php");
include ("include/functions_list_translate.php");


$db	= dbConnect();
insertCheckAuth(false);				// Enabling or Disabling mandatory login requirement. 

$category	= $_GET["category"];		// Category through which user traversed, if traversed by category
$file_list	= $_GET["file_list"];		// Whether the user traversed File wise
$file_id	= $_GET["file_id"];		// The File containing the string_value, when viewed File wise
$funtrans	= $_GET["funtrans"];		// View Untranslated strings of a File
$page		= $_GET["page"];		// Page number of the File List page from where the user reached here
$auto		= 0;				// View Automated/Machine generated suggestion


if($_POST["string_id"])				// String ID
{
    $string_id = $_POST["string_id"];
}
else
{
    $string_id = $_GET["sid"];
}

if(!get_magic_quotes_gpc())
{
    $user_sug 	= addslashes($_POST["user_sug"]);
    $comments 	= addslashes($_POST["user_comments"]);
}
else
{
    $user_sug 	= $_POST["user_sug"];			// User suggestion
    $comments 	= $_POST["user_comments"];		// User comments
}

$sug_type	= $_POST["selected_suggestion_id"];	// Existing Suggestion or New suggestion
$context	= $_POST["context"];			// All Context selected
$context_id	= $_POST["context_id"];			// Context Id selected
$lang		= $_POST["lang"];			// Get language of the post
$is_fuzzy	= $_POST["is_fuzzy"];			// Fuzzy suggestion
$is_fuzzy       = ($is_fuzzy) ? 1 : 0;

// Cookie for display automated suggestion option
if ($_GET["auto"])
{
    setcookie("auto_sug", $_GET["auto"], time() + 60*60*24*100);	// Cookie valid for 100 days
    $auto	= $_GET["auto"];
}
else if(isset($_COOKIE["auto_sug"]))
{
    $auto	= $_COOKIE["auto_sug"];
}

if (!$file_id)
{
    if($_GET["lang"])
    {
        $lang	= $_GET["lang"];
        setcookie("lang_id",$lang);
    }
    else 
    {
        $lang	= $_COOKIE["lang_id"];
    }
    $lang_list	= getLangList($string_id);
}
else
{
    $lang	= getLang($file_id);	   
}

/***************************** End of Variable Initialization ***************************************************/

// Voting or Validating
if ( $sug_type != "user" && $sug_type != "mach" && $sug_type )
{
    $selected_suggestion_id	= $sug_type;		// Selected Suggestion's Id
    if( $_SESSION['user_role'] == "validator")		// Validation
    {
        if($context != "all_context")		// Validation for particular context(s)
        {
            updateComments($selected_suggestion_id, $comments);
            if (is_array($context_id))			// Remove this condition. Implement it in Javascript
                validateArrayContext($selected_suggestion_id, $is_fuzzy, $context_id);
        }
        else				// Validation is made for All context
        {
            updateComments($selected_suggestion_id, $comments);
            validateAllContext($selected_suggestion_id, $is_fuzzy, $string_id, $lang);
        }
    }
    else	// Voting by users (Non-Validators)
    {
        $vote_submitted	= incrementVote($selected_suggestion_id);
    }

}
else if ($_POST["user_sug"] && ($sug_type=="user" || $sug_type=="mach"))	// Make new suggestion
{
    submitSuggestionComment($string_id,$user_sug,$lang,$comments,$is_fuzzy);
}


// Moving to the next or previous String
if ($_POST["mov"])
{
    $mov	= $_POST["mov"];				// Move direction
    moveSuggestionPage($mov, $string_id);
}
else if ($_GET["mov"]) 
{
    $mov	= $_GET["mov"];				// Move direction
    moveSuggestionPage($mov, $string_id);
}


// Get the String to be translated
$eng_string	= getStringValue($string_id);

if ($auto == 1)		// Automated Suggestion option is ON
{
    $mach_trans = "";
    $mach_trans	= getMachineTranslation ($eng_string, $lang);
    $mach_trans	= htmlentities ($mach_trans, ENT_COMPAT, 'UTF-8');
}


/******** Modified for Entrans v0.2 ***************/
//	Hints Generation Script - Get all the suggestions and valid translations for this string

if ($lang)
{	
    $sql_hint_query   	= "select distinct sug_id, user_suggestion, comments, is_fuzzy from ".
                          "$table_suggestion where ".
                          "string_id = $string_id and lang = '$lang' order by vote desc";
    $hint_result	    = mysql_query($sql_hint_query);
    $hint_array		    = mysql_fetch_array($hint_result);
}

$valid_sug		= array();
$all_valid_sug	= array();
$valid_sug		= getValidSugPerFile($string_id, $file_id);
$all_valid_sug	= getValidSugAllFiles($string_id);


include ("head.php");
?> 



<style type="text/css">
<!--
.siz12 {
    font-family: Verdana, Arial, Helvetica, sans-serif;
    font-size: 12px;
}
.siz13 {
    font-family: Verdana, Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.siz14 {
    font-family: Verdana, Arial, Helvetica, sans-serif;
    font-size: 14px;
}
.ver {
    font-family: Verdana, Arial, Helvetica, sans-serif;
}
.preview_area {
    background-color:#f5ffb9;
}
.fname {
    font-family : Courier;
    color : gray;
    padding-left : 25px;
}
.toplink {
    text-decoration: none;
}

.submit {  
  width: 150px;                 
}
.buttonbar li{
    float: left;
}
//-->
</style>


<script language="JavaScript" type="text/javascript" src="scripts/translate.js"> </script>
<script language="JavaScript" type="text/javascript" src="scripts/common.js"> </script>
<script language="JavaScript" type="text/javascript" src="scripts/IndicSupport.js"> </script>

<script language="JavaScript" type="text/javascript">
<!--
    var user_role = "<?echo $_SESSION['user_role'];?>";

function t_validate()
{
    var user_string,sug_checked, cvalue;
    var cbox_checked=0;
    var vote_option;
    if(!document.trans_form.lang.value)
    {
        alert("Please select the language of your suggestion");
        return false;
    }

    user_string = document.trans_form.user_sug.value;

    if( !document.trans_form.selected_suggestion_id.length)
    {
        if(document.trans_form.selected_suggestion_id.checked)
        {
            vote_option = document.trans_form.selected_suggestion_id.value;
            sug_checked=1;
        }
    }
    else
    {
        for (var i=0; i<document.trans_form.selected_suggestion_id.length;i++)
        {
            if(document.trans_form.selected_suggestion_id[i].checked)
            {
                vote_option = document.trans_form.selected_suggestion_id[i].value;
                sug_checked=1;
            }
        }
    }
    if(!sug_checked)
        window.alert("Please select a suggestion");
    if (vote_option =="user" && user_string == "")
        window.alert("Please fill in your Suggestion");
    else if(user_role !="validator")
    {
        document.trans_form.submit();
    }
    else
    {
        if(document.trans_form.context.checked)
        {
            document.trans_form.submit();
        }
        else
        {
/*
    var context_box = new Array();
context_box = document.trans_form.context_id;
alert(context_box);
type	= context_box.type;
alert(type);
len	= context_box[0].checked;
alert(len);
 */
            document.trans_form.submit();
        }
    }
    return false; 
}

function sub_continue()
{
    document.trans_form.mov.value = "next";
    if(!t_validate())
    {
        document.trans_form.mov.value = "";
    }
}
//-->
</script>


<?php
include ("body.php");
?>

   <ul id="navibar">
    <li class="wikilink"><a href="main.php">Home</a></li>
    <li class="wikilink"><a href="list.php?category=untrans&amp;page=1">Untranslated Strings</a></li>
<?php
    $link	= "?category=$category";
    if($category=="all") 
    {
        echo "<li class=\"wikilink\"> ";
        echo "<a href=\"list.php?category=all&amp;page=1\">All Strings</a></li>";
    }
    if ($file_list)
    { 
        if($file_id) 
        {
/*		    echo "<li class=\"wikilink\"> ";
            echo "<a href=\"list.php?file_list=$file_list&amp;page=1\">".
             "File List</a></li>";
 */
            echo "<li class=\"wikilink\"> ";
            echo "<a href=\"list.php?file_list=$file_list&amp;file_id=$file_id&amp;page=1\">".
                 "File Contents</a></li>";
            $link	= "?file_list=yes&amp;file_id=$file_id&amp;funtrans=$funtrans";
        }
        else
        {
            echo "<li class=\"wikilink\"> ";
            echo "<a href=\"list.php?file_list=$file_list&amp;page=1\">".
                 "File List</a></li>";
        }
    }
?>
    <li class="current"><a href="">Suggestion Page</a></li>
<?php	if($page)
        {
            echo '<li class="wikilink">';
            echo "<a href =\"list.php$link&amp;page=$page\">Back</a></li>";
        }
?>
    <li class="wikilink"><a href="help.php">Help</a></li>
   </ul>

<div id="pageline"><hr style="display:none;"></div>

</div>

<ul class="editbar">
    <li>

         <form name="indicForm" method="GET" action="#">
         <div title="[Alt+K]Select language and Keyboard layout- Inscript, WX, RTS">
                 <input type="hidden" name="offset" value="">
                 <input type="hidden" name="convertFlag" value="">
                 <select name="selectLanguage" onChange="selectLang(this);">
                     <option selected>Select Keyboard Map</option>
                     <option label="inscript" value=-1>English</option>
                     <option label="inscript" value=0>Hindi - Inscript</option>
                     <option label="wx" value=0>Hindi - WX</option>
                     <option label="multi_hindi_rts">Hindi - RTS</option>
                     <option label="inscript" value=0>Marathi - Inscript</option>
                     <option label="wx" value=0>Marathi - WX</option>
                     <option label="multi_marathi_rts">Marathi - RTS</option>
                     <option label="multi_nepali_xkb">Nepali - XKB</option>
                     <option label="inscript" value=1>Bengali - Inscript</option>
                     <option label="wx" value=1>Bengali - WX</option>
                     <option label="inscript" value=2>Gurumukhi - Inscript</option>
                     <option label="wx" value=2>Gurumukhi - WX</option>
                     <option label="inscript" value=3>Gujarathi - Inscript</option>
                     <option label="wx" value=3>Gujarathi - WX</option>
                     <option label="inscript" value=4>Oriya - Inscript</option>
                     <option label="wx" value=4>Oriya - WX</option>
                     <option label="inscript" value=5>Tamil - Inscript</option>
                     <option label="wx" value=5>Tamil - WX</option>
                     <option label="multi_tamil_rts">Tamil - RTS</option>
                     <option label="inscript" value=6>Telugu - Inscript</option>
                     <option label="wx" value=6>Telugu - WX</option>
                     <option label="multi_telugu_rts">Telugu - RTS</option>
                     <option label="inscript" value=7>Kannada - Inscript</option>
                     <option label="wx" value=7>Kannada - WX</option>
                     <option label="inscript" value=8>Malayalam - Inscript</option>
                     <option label="wx" value=8>Malayalam - WX</option>
                 </select>
         </div>

             <div title="[Alt+H]Show hint menu for the keyboard map while typing(for selected keymaps only)"
              id="div_keymap_hint" style="display:none">
                 <small>Keymap <u>H</u>int</small>
                 <input type="checkbox" name="chk_show_hint" onClick="togHintMenu();">
         </div>
             <div title="[Alt+M]View Machine Translation & Transliteration">
                 <small>View Auto<u>m</u>ated Suggestions</small>
                 <input type="checkbox" name="auto_sug" 
            <?php if ($auto == 1) echo "Checked"; ?> 
            onClick="togViewAutoSug();">
         </div>

         </form>

</li>
</ul>


<div id="tpage" >
<?php

$link_prev	= "$link&amp;page=$page&amp;sid=$string_id&amp;mov=prev";
$link_next	= "$link&amp;page=$page&amp;sid=$string_id&amp;mov=next";

?>

    <form name="trans_form" method="POST" action="">
    <input type="hidden" name="lang" value="<?php echo $lang; ?>">
    <input type="hidden" name="mov" value="">
    <input type="hidden" name="string_id" value="<?php echo $string_id; ?>">
    <?php
    if($file_list)
    {
    ?>
        <input type="hidden" name="file_list" value="yes">
        <input type="hidden" name="file_id" value="<?php echo $file_id; ?>">
    <?php
    }
    else if($category)
    {
    ?>
    <input type="hidden" name="category" value="<?php echo $category; ?>">
    <?php
    }
    ?>
    <table width="100%"   cellpadding="5" cellspacing="0" align="center" class="tdborder" >

       <tr valign="top" class="tdbottom">
            <td colspan="2" align="center" bgcolor="#ffffff">
            <table width="100%">
            <tr>
               <td width ="20%" align="left" > 
                <div title="[Alt+P]"><a href="<?php echo $link_prev; ?>">Prev</a></div></td>
               <td align="center"><b> Fill in your suggestion </b></td>
               <td width="20%"  align="right"> 
                <div title="[Alt+N]"><a href="<?php echo $link_next; ?>">Next</a></div></td>
            </tr>
           </table>
        </td>
       </tr>

       <tr>
            <td width="20%" align="left" bgcolor="#efefef"> String to be Translated </td>
        <td width="80%" class="ver" align="left" >
            <span ><?php echo htmlentities($eng_string,ENT_COMPAT,'UTF-8'); ?></span>
            <span style="display:none" id="eng_string"><?php echo htmlentities(makePhonetic($eng_string)); ?></span>
        </td> 
       </tr>
       <tr>
        <td bgcolor="#efefef"> &nbsp; </td> 
        <td >&nbsp;</td> 
       </tr>

<?php
if($_SESSION['user_role'] == "validator")
{
?>
       <tr >
            <td align="left" valign="top" align="left" bgcolor="#efefef" > 
            Please choose the context of your translation 
        </td>
        <td width="80%"  align="left" > 
<?php 
    $context_array	= getContextList($string_id, $lang);
    foreach ($context_array as $context)
    {
        echo '<input type="checkbox" name="context_id[]"'.
            'value="'.$context["id"].'">';
        echo $context["value"];
        echo '<br/>';
        echo '<span class="fname"><b>File</b>: '.$context["file"].'; '.
            '<b>Lang</b>: '.$context["lang"].'</span>';
        echo '<br/>';
    }
?>
        <input type="checkbox" name="context" value="all_context" checked > Use Suggestion for ALL context
        </td>
       </tr>
       <tr> <td  bgcolor="#efefef"> &nbsp;</td><td>&nbsp;</td> </tr>

<?php
}

if (!$file_id)
{
?>
       <tr>
            <td align="left" valign="top" align="left" bgcolor="#efefef" > 
            Choose the language of your translation 
        </td>
        <td width="80%"  align="left" >
<?php
    echo '<select name="lang_sel" class="submit_sel" onChange="setLang(\''.$lang.'\');">';
    echo '<option value=""> </option>';
    foreach ($lang_list as $lang_value)
    {
        $selected	= "";
        if ($lang_value	== $lang)
            $selected = "selected";
        if ($lang_value) {
            echo '<option value="'.$lang_value.'" '.$selected .'>'.getLangName($lang_value).
                 " ($lang_value)".'</option>';
        }
    }
    echo '</select>';
?>
        </td>
       </tr>
       <tr> <td  bgcolor="#efefef"> &nbsp;</td><td>&nbsp;</td> </tr>

<?php
}

echo " <tr> <td bgcolor=\"#efefef\" valign=\"top\"> Suggestion Options ";
echo "</td>";
echo "<td>";
if (!$lang)
{
    echo '<div class="warning"><i>';
    echo 'Please select your language of translation before proceeding';
    echo '</i></div>';
}
else
{
    echo '<div style="margin-bottom:10px" title="[Alt+1] to select 1st suggestion and so on.">';
    if ($hint_array)
    {
        do
    {
        $user_suggestion_id = $hint_array["sug_id"];
        $comments	    = $hint_array["comments"];
        $valid 		    = 0;

?>
            <input  type="radio" name="selected_suggestion_id"  
                value="<?php echo $user_suggestion_id; ?>" 
                alt="<?php echo htmlentities($hint_array["user_suggestion"],ENT_COMPAT,'UTF-8'); ?>" 
                label="<?php echo $hint_array["is_fuzzy"]; ?>"
                onClick="togUserText();" > 
<?php

        echo htmlentities($hint_array["user_suggestion"],ENT_COMPAT,'UTF-8');
        $valid_count	= count($valid_sug);
        for ($i=0;$i<$valid_count;$i++)
        {
            if($hint_array["sug_id"] == $valid_sug[$i])
            {
                echo "&nbsp;&nbsp;<img src=\"images/valid.png\" alt=\"Valid\">";
                $valid	= 1;
            }
        }
        if (!$valid)
        {
            $all_valid_count	= count($all_valid_sug);
            for ($i=0;$i<$all_valid_count;$i++)
            {
                if($hint_array["sug_id"] == $all_valid_sug[$i])
                {
                    echo '&nbsp;&nbsp;'.
                        '<img src="images/other_valid.png" alt="Valid in other File/Context">';
                    $valid	= 1;
                }
            }

        }
        if($_SESSION['user_role']=="validator" && !$valid)
        {
            echo "<span class=\"siz12\" style=\"padding-left:5px\">";
            echo "(<a href=\"delete.php?sugid=$user_suggestion_id&amp;file=$file_id\">Delete</a>)";
            echo "</span>";
        }

        // Hidden comments are used to display in "Comments" text area on user click of radio button
        echo "<input type=\"hidden\" name=\"comments$user_suggestion_id\" ".
            "value=\"$comments\">";

        echo "<br />";

    }while($hint_array = mysql_fetch_array($hint_result));
    }// End of Hint_Array

    if ($auto == 1)
    {
?>
            <input type="radio" name="selected_suggestion_id" value="mach"  
            alt="<?php echo $mach_trans; ?>" onClick="togUserText();"> <?php echo $mach_trans; ?>
        &nbsp;
        <img src="images/mach.png" alt="Machine Translation"><br/>
            <input type="radio" name="selected_suggestion_id" value="mach"
             alt="" onClick="togUserText();"><span id="mach_translit">&nbsp;Transliteration N/A</span>
            <img src="images/mach.png" alt="Machine Transliteration"><br/>

<?php       } ?>
            <input type="radio" name="selected_suggestion_id" value="user" checked label="" onClick="togUserText();">
            Other
        </div>
        <ul style="margin-top:5;" class="buttonbar">
        <li class="buttonlink"> 
            <a href="poll.php?sid=<?php echo $string_id; ?>"
               class="siz13" onClick="return popup(this,'Poll_Results')">More Details</a>
        </li>
        <li class="buttonlink">
        <span onMouseover="cssdropdown.dropit(this,event,'droplegends');">Legends</span>
        </li>
        </div>
<?php
}  // End of If-Else (!$lang)  ?>
        </td>
      </tr>

      <tr> 	
        <td bgcolor="#efefef">&nbsp;</td>
        <td>
<?php if($vote_submitted) { ?>
        <span class="warning">Your vote has been recorded.</span>
<?php } ?>
        &nbsp;</td>
       </tr>

       <tr>
           <td bgcolor="#efefef"></td><td><input type="checkbox" name="is_fuzzy">&nbsp;Mark Suggestion as Fuzzy</td>
       </tr>

       <tr>
        <td bgcolor="#efefef" valign="top"> Your Suggestion</td>
        <td align="left"><div title="[Alt+S]"><textarea name="user_sug" class="indic_ime" cols="80" rows="2" ></textarea>
        </div></td>
       </tr>

       <tr>
        <td bgcolor="#efefef" valign="top"> Comments for Suggestion</td>
        <td align="left"><textarea name="user_comments" class="user_comments" cols="80" rows="2"></textarea></td>
       </tr>

       <tr>
        <td bgcolor="#efefef"> &nbsp; </td>
        <td>
<?php
if ($lang)
{
?>
            <table width="75%">
                <tr>
                            <td align="left">
                        <div title="[Ctrl+Alt+Enter]">
                        <input type="button" name="submit_suggestion" class="submit" value="Submit My Suggestion" 
                        onClick="<?php echo "t_validate()"; ?>"></div>
                </td>
                <td align="right">
                        <div title="[Alt+Enter]">
                        <input type="button" name="submit_continue" class="submit" value="Submit & Continue" 
                        onClick="sub_continue();"></div>
                </td>
            </tr>
            </table>
<?php
}
else
    echo '&nbsp;';
?>
        </td>
           </tr>

    </table>
    </form>

    <table width="100%"  bgcolor="#ffffff" cellpadding="5" >
    <tr>
        <td width ="50" align="left">
        <div title="[Alt+P]"><a name="link_prev" href="<?php echo $link_prev; ?>">Prev</a></div></td>
        <td align="center">
<?php	 if($file_id)
            echo '<b>'.getLangName($lang)." ($lang) </b> translation of <b>".getNodeName($file_id).'</b>';
        else
            echo "&nbsp;";

?>	    </td>
        <td width="50" align="right">
        <div title="[Alt+N]"><a name="link_next" href="<?php echo $link_next; ?>">Next</a></div></td>
    </tr>
    </table>
</div>

<div id="droplegends" class="dropmenudiv" style="width: 400px">
    <span>
        <img src="images/valid.png" height="15" hspace=5 alt="Valid: "> &nbsp; 
    Valid Translation for the current context, if any
    </span>
    <span>
    <img src="images/other_valid.png" height="15" hspace="5" alt="Valid in other File/Context"> &nbsp;
    Valid Translation for other context(s) of the same string
    </span>
    <span>
        <img src="images/mach.png" hspace="5" alt="Machine Transliteration"> &nbsp;
    Machine Translation and Transliteration
    </span>
</div>


<script type="text/javascript">
<!--
    var link_prev,link_next,auto;
document.trans_form.user_sug.focus();

findCheckedSuggestion();
link_prev=document.getElementsByName("link_prev")[0];
link_next=document.getElementsByName("link_next")[0];

auto = 0;   //will be used in indicSupport.js to provide machine transliteration
<?php
if($auto == 1) 
{
?>
    auto = 1;
<?php
}
?>
//-->
</script>
<?
mysql_close($db);
include ("footer.php");
?>
